"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var rp = __importStar(require("request-promise"));
var defaultOpts = function (s) { return ({
    timeout: 5000,
    rejectUnauthorized: !(s.options && s.options.insecure),
    jar: s.cookieJar
}); };
var Bucket = /** @class */ (function () {
    function Bucket(uiUrl, name, username, password, options) {
        this.uiUrl = uiUrl;
        this.name = name;
        this.username = username;
        this.password = password;
        this.options = options;
        this.cookieJar = rp.jar();
    }
    Bucket.prototype.authorize = function () {
        var opts = __assign({}, defaultOpts(this), { uri: this.uiUrl + "/uilogin", rejectUnauthorized: !(this.options && this.options.insecure), jar: this.cookieJar, form: {
                user: this.username,
                password: this.password
            } });
        return new Promise(function (resolve, reject) {
            rp.post(opts)
                .then(function () { return resolve(); })
                .catch(function (err) { return reject(err); });
        });
    };
    Bucket.prototype.get = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var opts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.authorize()];
                    case 1:
                        _a.sent();
                        opts = __assign({}, defaultOpts(this), { uri: this.uiUrl + "/pools/default/buckets/" + this.name + "/docs/" + encodeURIComponent(key), headers: {
                                'ns-server-ui': 'yes'
                            } });
                        return [2 /*return*/, rp.get(opts).then(function (res) { return JSON.parse(JSON.parse(res).json); })];
                }
            });
        });
    };
    Bucket.prototype.query = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var opts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.authorize()];
                    case 1:
                        _a.sent();
                        opts = __assign({}, defaultOpts(this), { uri: this.uiUrl + "/_p/query/query/service", headers: {
                                'ns-server-ui': 'yes'
                            }, body: {
                                statement: query,
                                pretty: true,
                                scan_consistency: 'not_bounded'
                            }, json: true });
                        return [2 /*return*/, rp.post(opts).then(function (res) { return res.results; })];
                }
            });
        });
    };
    Bucket.prototype.list = function (skip, limit) {
        return __awaiter(this, void 0, void 0, function () {
            var opts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.authorize()];
                    case 1:
                        _a.sent();
                        opts = __assign({}, defaultOpts(this), { uri: this.uiUrl + "/pools/default/buckets/" + this.name + "/docs", headers: {
                                'ns-server-ui': 'yes'
                            }, qs: {
                                skip: skip,
                                limit: limit,
                                include_docs: false
                            } });
                        return [2 /*return*/, rp.get(opts).then(function (res) { return JSON.parse(res).rows.map(function (row) { return row.id; }); })];
                }
            });
        });
    };
    return Bucket;
}());
exports.default = Bucket;
